Index: /stable/HeuristicLab.Core.Views/3.3/CheckedItemCollectionView.cs
===================================================================
--- /stable/HeuristicLab.Core.Views/3.3/CheckedItemCollectionView.cs	(revision 12733)
+++ /stable/HeuristicLab.Core.Views/3.3/CheckedItemCollectionView.cs	(revision 12734)
@@ -32,4 +32,5 @@
   [Content(typeof(ICheckedItemCollection<>), true)]
   [Content(typeof(CheckedItemCollection<>), true)]
+  [Content(typeof(ReadOnlyCheckedItemCollection<>), true)]
   public partial class CheckedItemCollectionView<T> : ItemCollectionView<T> where T : class, IItem {
     public new ICheckedItemCollection<T> Content {
Index: /stable/HeuristicLab.Core.Views/3.3/CheckedItemListView.cs
===================================================================
--- /stable/HeuristicLab.Core.Views/3.3/CheckedItemListView.cs	(revision 12733)
+++ /stable/HeuristicLab.Core.Views/3.3/CheckedItemListView.cs	(revision 12734)
@@ -35,4 +35,5 @@
   [Content(typeof(CheckedItemList<>), true)]
   [Content(typeof(ICheckedItemList<>), true)]
+  [Content(typeof(ReadOnlyCheckedItemList<>), true)]
   public partial class CheckedItemListView<T> : ItemListView<T> where T : class, IItem {
     public new ICheckedItemList<T> Content {
Index: /stable/HeuristicLab.Core.Views/3.3/ItemArrayView.cs
===================================================================
--- /stable/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 12733)
+++ /stable/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 12734)
@@ -28,5 +28,4 @@
 using HeuristicLab.Collections;
 using HeuristicLab.MainForm;
-using HeuristicLab.MainForm.WindowsForms;
 using HeuristicLab.PluginInfrastructure;
 
@@ -35,4 +34,5 @@
   [Content(typeof(ItemArray<>), true)]
   [Content(typeof(IItemArray<>), false)]
+  [Content(typeof(ReadOnlyItemArray<>), true)]
   public partial class ItemArrayView<T> : ItemView where T : class, IItem {
     protected Dictionary<T, List<ListViewItem>> itemListViewItemMapping;
Index: /stable/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs
===================================================================
--- /stable/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 12733)
+++ /stable/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 12734)
@@ -29,5 +29,4 @@
 using HeuristicLab.Common;
 using HeuristicLab.MainForm;
-using HeuristicLab.MainForm.WindowsForms;
 using HeuristicLab.PluginInfrastructure;
 
@@ -36,4 +35,5 @@
   [Content(typeof(ItemCollection<>), true)]
   [Content(typeof(IItemCollection<>), false)]
+  [Content(typeof(ReadOnlyItemCollection<>), true)]
   public partial class ItemCollectionView<T> : ItemView where T : class, IItem {
     protected Dictionary<T, List<ListViewItem>> itemListViewItemMapping;
Index: /stable/HeuristicLab.Core.Views/3.3/ItemListView.cs
===================================================================
--- /stable/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 12733)
+++ /stable/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 12734)
@@ -30,5 +30,4 @@
 using HeuristicLab.Common;
 using HeuristicLab.MainForm;
-using HeuristicLab.MainForm.WindowsForms;
 using HeuristicLab.PluginInfrastructure;
 
@@ -37,4 +36,5 @@
   [Content(typeof(ItemList<>), true)]
   [Content(typeof(IItemList<>), false)]
+  [Content(typeof(ReadOnlyItemList<>), true)]
   public partial class ItemListView<T> : ItemView where T : class, IItem {
     protected Dictionary<T, List<ListViewItem>> itemListViewItemMapping;
Index: /stable/HeuristicLab.Core.Views/3.3/ItemSetView.cs
===================================================================
--- /stable/HeuristicLab.Core.Views/3.3/ItemSetView.cs	(revision 12733)
+++ /stable/HeuristicLab.Core.Views/3.3/ItemSetView.cs	(revision 12734)
@@ -28,4 +28,5 @@
   [Content(typeof(ItemSet<>), true)]
   [Content(typeof(IItemSet<>), false)]
+  [Content(typeof(ReadOnlyItemSet<>), true)]
   public partial class ItemSetView<T> : ItemCollectionView<T> where T : class, IItem {
     protected bool draggedItemsAlreadyContained;